local
  open Term Prop Seq Rules Top
  
  val A = Atom ("A", [])
  val B = Atom ("B", [])
  val Q = Atom ("Q", [])
  fun P(t) = Atom ("P", [t])

in
  (* |- A -o A *)
  val _ = prove (Lolli (A, A))
  val _ = apply (lolliR)
  val _ = apply (initial)
  val _ = judgment ()

  (* |- A * B -o B * A *)
  val _ = prove (Lolli (Tensor (A, B), Tensor (B, A)))
  val _ = apply (lolliR)
  val _ = apply (tensorL 1)
  val _ = apply (tensorR ([1],[2]))
  val _ = apply (initial)
  val _ = apply (initial)
  val _ = if judgment () then () else raise Error

  (* |- (forall x. Q -o P(x)) -o (Q -o forall x. P(x)) *)
  val _ = prove (Lolli (Forall ("x", Lolli (Q, P (Var("x")))),
			Lolli (Q, Forall ("x", P (Var("x"))))))
  val _ = apply (lolliR)
  val _ = apply (lolliR)
  val _ = apply (forallR "a")
  val _ = apply (forallL (Parm("a")) 2)
  val _ = apply (lolliL ([2],[]) 1)
  val _ = apply (initial)
  val _ = apply (initial)
  val _ = if judgment () then () else raise Error

  (* |- (Q -o forall x. P(x)) -o (forall x. Q -o P(x)) *)
  val _ = prove (Lolli (Lolli (Q, Forall ("x", P (Var("x")))),
			Forall ("x", Lolli (Q, P (Var("x"))))))
  val _ = apply (lolliR)
  val _ = apply (forallR "a")
  val _ = apply (lolliR)
  val _ = apply (lolliL ([1],[]) 2)
  val _ = apply (initial)
  val _ = apply (forallL (Parm("a")) 1)
  val _ = apply (initial)
  val _ = if judgment () then () else raise Error

end;
